Further to Josef's review.
diff --git a/tests/btrfs/301 b/tests/btrfs/301
new file mode 100755
index 000000000000..5f8abdbe157a
--- /dev/null
+++ b/tests/btrfs/301
@@ -0,0 +1,94 @@
+#! /bin/bash
+# SPDX-License-Identifier: GPL-2.0
+# Copyright (c) 2023 Guilherme G. Piccoli (Igalia S.L.). All Rights Reserved.
+#
+# FS QA Test 301
+#
+# Test for the btrfs single-dev feature - both mkfs and btrfstune are
+# validated, as well as explicitly unsupported commands, like device
+# removal / replacement.
+#
+. ./common/preamble
+_begin_fstest auto mkfs quick
+. ./common/filter
Normally we group all the require'd stuff together
+_supported_fs btrfs
+
+_require_btrfs_mkfs_feature single-dev
+_require_btrfs_fs_feature single_dev
+
+_require_scratch_dev_pool 2
+_scratch_dev_pool_get 1
+_spare_dev_get
+
+_require_command "$BTRFS_TUNE_PROG" btrfstune
+_require_command "$WIPEFS_PROG" wipefs
+
+# Helper to mount a btrfs fs
+# Arg 1: device
+# Arg 2: mount point
+mount_btrfs()
+{
+ $MOUNT_PROG -t btrfs $1 $2
+ [ $? -ne 0 ] && _fail "mounting $1 on $2 failed"
+}
+
+SPARE_MNT="${TEST_DIR}/${seq}/spare_mnt"
Please use small case for test local variables.
spare_mnt=="${TEST_DIR}/${seq}/spare_mnt"
Thanks, Anand
+mkdir -p $SPARE_MNT
+
+
+# Part 1
+# First test involves a mkfs with single-dev feature enabled.
+# If it succeeds and mounting that FS *twice* also succeeds,
+# we're good and continue.
+$WIPEFS_PROG -a $SCRATCH_DEV >> $seqres.full 2>&1
+$WIPEFS_PROG -a $SPARE_DEV >> $seqres.full 2>&1
+
+_scratch_mkfs "-b 300M -O single-dev" >> $seqres.full 2>&1
+dd if=$SCRATCH_DEV of=$SPARE_DEV bs=300M count=1 conv=fsync >> $seqres.full 2>&1
+
+mount_btrfs $SCRATCH_DEV $SCRATCH_MNT
You can just use _scratch_mount here, since you want to handle failures just
_scratch_mount || _fail "failed to mount scratch mount"
+mount_btrfs $SPARE_DEV $SPARE_MNT
Instead use _mount here
_mount $SPARE_DEV $SPARE_MNT || _fail "failed to mount spare dev"
+
+$UMOUNT_PROG $SPARE_MNT
+$UMOUNT_PROG $SCRATCH_MNT
_scratch_unmount
+
+
+# Part 2
+# Second test is similar to the first with the difference we
+# run mkfs with no single-dev mention, and make use of btrfstune
+# to set such feature.
+$WIPEFS_PROG -a $SCRATCH_DEV >> $seqres.full 2>&1
+$WIPEFS_PROG -a $SPARE_DEV >> $seqres.full 2>&1
+
+_scratch_mkfs "-b 300M" >> $seqres.full 2>&1
+$BTRFS_TUNE_PROG --convert-to-single-device $SCRATCH_DEV
+dd if=$SCRATCH_DEV of=$SPARE_DEV bs=300M count=1 conv=fsync >> $seqres.full 2>&1
+
+mount_btrfs $SCRATCH_DEV $SCRATCH_MNT
_scratch_mount
+mount_btrfs $SPARE_DEV $SPARE_MNT
_mount
+
+$UMOUNT_PROG $SPARE_MNT
+$UMOUNT_PROG $SCRATCH_MNT
_scratch_unmount
+
+
+# Part 3
+# Final part attempts to run some single-dev unsupported commands,
+# like device replace/remove - it they fail, test succeeds!
+mount_btrfs $SCRATCH_DEV $SCRATCH_MNT
_scratch_mount
+
+$BTRFS_UTIL_PROG device replace start $SCRATCH_DEV $SCRATCH_DEV $SCRATCH_MNT 2>&1 \
+ | _filter_scratch
+
+$BTRFS_UTIL_PROG device remove $SCRATCH_DEV $SCRATCH_MNT 2>&1 \
+ | _filter_scratch
+
+$UMOUNT_PROG $SCRATCH_MNT
_scratch_unmount
+
+_spare_dev_put
+_scratch_dev_pool_put 1
+
+# success, all done
+status=0
+echo "Finished"
Don't need this bit. Thanks,
Josef